import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api';
import type { ThinkIntegral, ThinkIntegralParam } from './model';
import { THINK_API_URL } from '@/config/setting';

/**
 * 分页查询
 */
export async function pageThinkIntegral(params: ThinkIntegralParam) {
  const res = await request.get<ApiResult<PageResult<ThinkIntegral>>>(
    THINK_API_URL + '/think/think-integral/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询列表
 */
export async function listThinkIntegral(params?: ThinkIntegralParam) {
  const res = await request.get<ApiResult<ThinkIntegral[]>>(
    THINK_API_URL + '/think/think-integral',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加
 */
export async function addThinkIntegral(data: ThinkIntegral) {
  const res = await request.post<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-integral',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改
 */
export async function updateThinkIntegral(data: ThinkIntegral) {
  const res = await request.put<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-integral',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除
 */
export async function removeThinkIntegral(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-integral/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除
 */
export async function removeBatchThinkIntegral(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    THINK_API_URL + '/think/think-integral/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询
 */
export async function getThinkIntegral(id: number) {
  const res = await request.get<ApiResult<ThinkIntegral>>(
    THINK_API_URL + '/think/think-integral/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
